/*
 * basic.c
 *
 * Created: 2014-04-15 13:11:17
 *  Author: dsosnowski
 */ 


//---------------------------------------
//includes
#define F_CPU 8000000UL
#include <avr/io.h>
#include <avr/interrupt.h>
#include <inttypes.h>
#include <util/delay.h>
#include <avr/wdt.h>
#include <avr/sleep.h>
//#include <avr/pgmspace.h>
//#include "serial.h"
//#include "scanner.h"
#include "defs.h"
#include "basic.h"

struct {
	char led;	
	char click;
	char long_press;
} ui;


//-------------------------------------------------
void LedState(char state)
{
	if (state)
	{
		ui.led = 1;
	}		
	else
	{
		ui.led = 0;
	}
}

//-------------------------------------------------
char UiProc(void)
{
	static char led_delay;
	char temp;
	
	//cli();
	//temp = 0;
	//DDRB  &= ~(1<<LED_PIN);
	//PORTB |=  (1<<LED_PIN);

	//_delay_ms(1);	
	//if ((PINB & (1<<SW_PIN)) == 0) temp = 1;
	//PORTB &= ~(1<<LED_PIN);
	if (ui.led) LED_SET;
	else LED_CLR;
	//sei();
	
	temp = IR_GET;
	if (temp == 0)
	{
		if (ui.long_press < 0xFF)	ui.long_press++;
		if (ui.long_press == HOLD_THRESHOLD) ui.click = SW_HOLD;
		led_delay = 0;
	}
	else
	{
		//if ((ui.long_press > 1) && (ui.long_press <  CLICK_THRESHOLD)) ui.click = SW_CLICK;
		//if (long_press == HOLD_THRESHOLD) ui.click = SW_HOLD;
		ui.long_press = 0;	
		
		/*if (led_delay < LED_THRESHOLD) led_delay++;
		else 
		{
			if (!(ui.led)) DDRB  &=  ~(1<<LED_PIN);
		}*/
	}
	return ui.click;
}

//-------------------------------------------------
void PowerState(char state)
{
	if (state)
	{
		PORTB |= (1<<RELAY_PIN);
	}
	else
	{
		PORTB &= ~(1<<RELAY_PIN);		
	}	
}

//-------------------------------------------------
void MotorState(char state)
{
	if (state == MOTOR_STOP)
	{
		PORTB &= ~(1<<MOTOR_N_PIN | 1<<MOTOR_P_PIN);		
	}
	else if (state == MOTOR_RIGHT)
	{
		PORTB &= ~(1<<MOTOR_N_PIN);				
		PORTB |=  (1<<MOTOR_P_PIN);				
	}
	else if (state == MOTOR_LEFT)
	{
		PORTB &= ~(1<<MOTOR_P_PIN);				
		PORTB |=  (1<<MOTOR_N_PIN);								
	}
}