/*
 * lift_594.c
 *
 * Created: 2014-05-08 10:33:38
 *  Author: dsosnowski
 */ 

//---------------------------------------
//includes
#define F_CPU 8000000UL
#include <avr/io.h>
#include <avr/interrupt.h>
#include <inttypes.h>
#include <util/delay.h>
#include <avr/wdt.h>
#include <avr/sleep.h>
//#include <avr/pgmspace.h>
#include "scanner.h"
#include "defs.h"
#include "basic.h"
#include "wdog.h"


//-------------------------------------------------
void HardInit(void);


//-------------------------------------------------
extern struct {
	char led;	
	char click;
	char long_press;
} ui;

extern struct {
	volatile char status;	
	volatile char result;
	volatile char index;
	char buffer[SCAN_BUFF_SIZE];
} scan;

struct {
	char state;
	char action;
	char prog;
	char blink;
	char volume_repeat;
	char volume_prev;
} system;



#define VOLUME_REPEAT		10

//-------------------------------------------------
int main(void)
{
	char i;
	
	HardInit();
	_delay_ms(300);
	ScannerInit();
	sei();
	
	ScannerStart();
	
    while(1)
    {		
			
		//---------------------------------------
		if (system.prog == 0)
		{		
			//-----------------------------------
			if (UiProc())
			{
				if (ui.click == SW_CLICK)
				{
				//	system.action = POWER_ACTION;
				}
			
				if (ui.click == SW_HOLD)
				{
					system.action = PROG_MODE;
				}
			
				ui.click = 0;
			}
			//-----------------------------------
			//else
			//{
				if (scan.status == SCAN_COMPLETE)
				{

					i = ScannerComp();
					system.action = 0;				
					
					if ((i == 1) || (i == 2)) {
						system.action = VOLUME_UP;
						system.volume_prev = VOLUME_UP;
						system.volume_repeat = VOLUME_REPEAT;
					}
					
					if ((i == 3) || (i == 4)) {
						system.action = VOLUME_DOWN;
						system.volume_prev = VOLUME_DOWN;
						system.volume_repeat = VOLUME_REPEAT;
					}
						
					if ((i == 5) || (i == 6)) system.action = POWER_ACTION;
					
					if (system.action == 0) {
						if (system.volume_repeat > 0) {
							system.action = system.volume_prev;
							system.volume_repeat = VOLUME_REPEAT;
						}
					}
					
					
					if (system.action) 
					{
						//LED_SET;
						_delay_ms(25);
						//LED_CLR;
						_delay_ms(25);
						//if (ui.led) 
						//LED_SET;
					}
					
					scan.status = SCAN_IDLE;
					ScannerStart();
	
				}				
			//}
			
			//-----------------------------------
			if (system.action)
			{
				if (system.action == POWER_ACTION) 
				{
					if (system.state)
					{
						system.state = 0;
						LedState(LED_OFF);
						PowerState(POWER_OFF);
					}
					else
					{
						system.state = 1;
						LedState(LED_ON);
						PowerState(POWER_ON);
					}					
					
					_delay_ms(400);
					ScannerStop();
					scan.status = SCAN_IDLE;
					ScannerStart();													

				}
				
				if (system.action == VOLUME_UP)
				{
					MotorState(MOTOR_RIGHT);
					_delay_ms(150);
				}
								
				if (system.action == VOLUME_DOWN)
				{
					MotorState(MOTOR_LEFT);
					_delay_ms(150);
				}
				
				if (system.action == PROG_MODE)
				{
					system.prog = 1;
					system.blink = 0;
					LedState(LED_ON);
					LED_SET;
					PowerState(POWER_OFF);
					MotorState(MOTOR_STOP);
					ScannerStop();
					_delay_ms(200);
					
					while (IR_GET == 0)
						wdt_reset();
					_delay_ms(600);
					
					MotorState(MOTOR_RIGHT);
					_delay_ms(350);
					MotorState(MOTOR_STOP);				

					scan.status = SCAN_IDLE;
					ScannerStart();													
				}
				
				system.action = 0;
			}
			else
			{
				MotorState(MOTOR_STOP);				
			}
			
			if (system.volume_repeat) system.volume_repeat--;
		}				
		
		//---------------------------------------
		//if system.prog > 0
		else
		{
			//-----------------------------------
			if (UiProc())
			{
				ui.click = 0;
				//system.prog = 7;				
				//system.blink = 10;
			}
			//-----------------------------------
			else
			{
				if (system.prog < 7)
				{
					if (scan.status == SCAN_COMPLETE)
					{
						ScannerSave(system.prog);
						system.prog++;
						system.blink = 10;
					}
				}										
			}
			
			//-----------------------------------
			system.blink++;
			if (system.blink == 10) system.blink = 0;
			if (system.blink ==  0) LedState(LED_OFF);
			if (system.blink >   5) LedState(LED_ON);

			if (system.blink >  35) 
			{
				system.blink = 0;
				if (system.prog == 3)
				{
					MotorState(MOTOR_LEFT);
					_delay_ms(350);
					MotorState(MOTOR_STOP);				
				}
				if (system.prog == 5)
				{
					PowerState(POWER_ON);
					_delay_ms(600);
					PowerState(POWER_OFF);
				}
				if (system.prog >= 7) 
				{
					system.prog = 0;			
					system.state = 0;
					LedState(LED_OFF);
					PowerState(POWER_OFF);
				}				
				scan.status = SCAN_IDLE;
				ScannerStart();
			}			
		}
		
		//-----------------------------------
		_delay_ms(50);
		LED_CLR;
		wdt_reset();
    }
}

//-------------------------------------------------
void HardInit(void)
{
	PORTB = (1<<IR_PIN | 1<<LED_PIN);
	DDRB =  (1<<MOTOR_N_PIN | 1<<MOTOR_P_PIN | 1<<RELAY_PIN | 1<<LED_PIN);
	
	ACSR = (1<<ACD);
	PRR = (1<<PRUSI | 1<<PRADC | 1<<PRTIM1);
	
	WdtSet(7);
}
